=== lib-src/portaudio-v19/examples/CMakeLists.txt ===
# Example projects

MACRO(ADD_EXAMPLE appl_name)
   ADD_EXECUTABLE(${appl_name} "${appl_name}.c")
   TARGET_LINK_LIBRARIES(${appl_name} portaudio_static)
   SET_TARGET_PROPERTIES(${appl_name}
      PROPERTIES
      FOLDER "Examples C"
   )
ENDMACRO(ADD_EXAMPLE)

MACRO(ADD_EXAMPLE_CPP appl_name)
   ADD_EXECUTABLE(${appl_name} "${appl_name}.cpp")
   TARGET_LINK_LIBRARIES(${appl_name} portaudio_static)
   SET_TARGET_PROPERTIES(${appl_name}
      PROPERTIES
      FOLDER "Examples C++"
   )
ENDMACRO(ADD_EXAMPLE_CPP)

ADD_EXAMPLE(pa_devs)
ADD_EXAMPLE(pa_fuzz)
ADD_EXAMPLE(paex_mono_asio_channel_select)
ADD_EXAMPLE(paex_ocean_shore)
ADD_EXAMPLE(paex_pink)
ADD_EXAMPLE(paex_read_write_wire)
ADD_EXAMPLE(paex_record)
ADD_EXAMPLE(paex_record_file)
ADD_EXAMPLE(paex_saw)
ADD_EXAMPLE(paex_sine)
ADD_EXAMPLE_CPP(paex_sine_c++)
ADD_EXAMPLE(paex_wmme_ac3)
ADD_EXAMPLE(paex_wmme_surround)
ADD_EXAMPLE(paex_write_sine)
ADD_EXAMPLE(paex_write_sine_nonint)
