=== lib-src/libnyquist/nyquist/sys/unix/alsa/Makefile ===
#
# Makefile for Nyquist, SYSTEM-TYPE is ALSA
# run make in the top-level Nyquist directory to compile Nyquist
#
# NOTE: this file is machine-generated.  DO NOT EDIT!
#   Instead, modify makefile.lsp and regenerate the makefile.
#   Ports and bug fixes are welcome - please mail them to 
#   dannenberg@cs.cmu.edu.  Thanks.
#

# This is the resulting executable (normally "ny"):
NY = ny

OPT = -O2 -m32
# OPT = -g -m32

EVERYTHING = $(NY) runtime/system.lsp jnyqide/jNyqIDE.jar \
           bin/ser-to-osc bin/test-client

CURRENT = $(EVERYTHING)

current: $(CURRENT)

onlyny: $(NY) runtime/system.lsp

JAVASRC =  jnyqide/browser.java jnyqide/NyquistThread.java \
	jnyqide/Pair.java jnyqide/BareBonesBrowserLaunch.java \
	jnyqide/EnvelopeFrame.java jnyqide/Piano_Roll.java \
	jnyqide/FindDialog.java jnyqide/PlotFrame.java \
	jnyqide/InstrumentCharacteristics.java jnyqide/PlotMouseAdapter.java \
	jnyqide/Jslide.java jnyqide/PopupListener.java \
	jnyqide/LispFileFilter.java jnyqide/PreferencesDialog.java \
	jnyqide/MainFrame_AboutBox.java jnyqide/ReplaceDialog.java \
	jnyqide/MainFrame.java jnyqide/SpringUtilities.java jnyqide/Main.java \
	jnyqide/NotFoundDialog.java jnyqide/TextColor.java jnyqide/NyqPlot.java \
	jnyqide/Trie.java jnyqide/NyquistFile.java jnyqide/WordList.java

jnyqide/jNyqIDE.jar: $(JAVASRC)
	if [ -r jnyqide/SpecialMacHandler.java ] ; then \
	mv jnyqide/SpecialMacHandler.java jnyqide/SpecialMacHandler.hidden ;\
	fi 
	cd jnyqide; javac *.java 
	mv jnyqide/SpecialMacHandler.hidden jnyqide/SpecialMacHandler.java 
	rm -rf jnyqide/jNyqIDE.jar 
	jar -cfm jnyqide/jNyqIDE.jar jnyqide/manifest.txt jnyqide/*.class 

# Standard list of includes (common to all unix versions)
# Keeping portaudio and libsndfile sources local to nyquist
INCL = -Inyqsrc -Itran -Ixlisp -Isys/unix -Icmt -Iffts/src \
   -Inyqstk/include -Inyqstk -Iportaudio/include -Iportaudio/src/common \
   -Iportaudio/src/os/unix \
   -Iliblo -Inylsf -IFLAC/include -Ilibogg/include -Ilibvorbis/include

# system dependent stuff for alsa:

AUDIOLIBS = -lasound

CC = gcc

LIBPA_PATH = portaudio/lib/.libs
LIBOGG_PATH = libogg/src/.libs
LIBVORBIS_PATH = libvorbis/lib/.libs
LIBLO_PATH = liblo/src/.libs
LIBFLAC_PATH = FLAC/obj/release/lib

# to enable command line editing, use -DREADLINE. WARNING: THIS WILL 
# DISABLE THE ABILITY TO INTERRUPT LISP AND USE SOME OTHER HANDY 
# CONTROL CHARACTERS (You will also need the readline and curses libraries)
CFLAGS = -DOSC -DCMTSTUFF $(OPT) $(INCL) \
    -DHAVE_LIBPTHREAD=1 -D_FILE_OFFSET_BITS=64 \
    -DSTK_NYQUIST -DUSE_VSPRINTF \
    -DHAVE_CONFIG_H
LN = g++ -m32
AR = ar
# to enable command line editing, insert -lreadline -lcurses
LFLAGS = -L/usr/lib32 $(LIBPA_PATH)/libportaudio.a \
         $(LIBLO_PATH)/liblo.a $(AUDIOLIBS) $(LIBFLAC_PATH)/libFLAC.a \
         $(LIBVORBIS_PATH)/libvorbis.a \
         $(LIBVORBIS_PATH)/libvorbisfile.a \
         $(LIBVORBIS_PATH)/libvorbisenc.a $(LIBOGG_PATH)/libogg.a \
         -lm -lpthread -lrt

TAGS:
	find . ( -name "*.c" -o -name "*.h" ) -print | etags -

tags: TAGS

# end of system dependencies

INTGEN = misc/intgen

# Object files for Nyquist:
OBJECTS =  xlisp/extern.o xlisp/xldmem.o xlisp/xlbfun.o xlisp/xlcont.o \
	xlisp/xldbug.o xlisp/xleval.o xlisp/xlfio.o xlisp/xlftab.o \
	xlisp/xlglob.o xlisp/xlimage.o xlisp/xlinit.o xlisp/xlio.o \
	xlisp/xlisp.o xlisp/xljump.o xlisp/xllist.o xlisp/xlmath.o \
	xlisp/xlobj.o xlisp/xlpp.o xlisp/xlprin.o xlisp/xlread.o xlisp/xlstr.o \
	xlisp/xlsubr.o xlisp/xlsym.o xlisp/xlsys.o xlisp/path.o tran/abs.o \
	tran/allpoles.o tran/alpass.o tran/alpasscv.o tran/alpassvv.o \
	tran/amosc.o tran/areson.o tran/aresonvc.o tran/aresoncv.o \
	tran/aresonvv.o tran/atone.o tran/atonev.o tran/biquadfilt.o \
	tran/buzz.o tran/chase.o tran/clip.o tran/congen.o tran/const.o \
	tran/coterm.o tran/delaycc.o tran/delaycv.o tran/eqbandvvv.o tran/exp.o \
	tran/follow.o tran/fmosc.o tran/fromobject.o tran/fromarraystream.o \
	tran/gate.o tran/ifft.o tran/instrclar.o tran/instrclarall.o \
	tran/instrclarfreq.o tran/instrsax.o tran/instrsaxall.o \
	tran/instrsaxfreq.o tran/integrate.o tran/log.o tran/lpreson.o \
	tran/maxv.o tran/offset.o tran/oneshot.o tran/osc.o tran/partial.o \
	tran/pluck.o tran/prod.o tran/pwl.o tran/quantize.o tran/recip.o \
	tran/reson.o tran/resonvc.o tran/resoncv.o tran/resonvv.o \
	tran/sampler.o tran/scale.o tran/shape.o tran/sine.o tran/siosc.o \
	tran/slope.o tran/sqrt.o tran/tapf.o tran/tapv.o tran/tone.o \
	tran/tonev.o tran/upsample.o tran/white.o tran/stkrev.o \
	tran/stkpitshift.o tran/stkchorus.o tran/instrbow.o \
	tran/instrbowedfreq.o tran/instrbanded.o tran/instrmandolin.o \
	tran/instrsitar.o tran/instrmodalbar.o tran/instrflute.o \
	tran/instrflutefreq.o tran/instrfluteall.o tran/fmfb.o tran/fmfbv.o \
	cmt/cext.o cmt/cleanup.o cmt/cmdline.o cmt/cmtcmd.o cmt/moxc.o \
	cmt/mem.o cmt/midifile.o cmt/midifns.o cmt/record.o cmt/seq.o \
	cmt/seqmread.o cmt/seqmwrite.o cmt/seqread.o cmt/seqwrite.o \
	cmt/tempomap.o cmt/timebase.o cmt/userio.o nylsf/aiff.o nylsf/alaw.o \
	nylsf/au.o nylsf/audio_detect.o nylsf/avr.o nylsf/broadcast.o \
	nylsf/caf.o nylsf/chanmap.o nylsf/chunk.o nylsf/command.o \
	nylsf/common.o nylsf/dither.o nylsf/double64.o nylsf/dwd.o nylsf/dwvw.o \
	nylsf/file_io.o nylsf/flac.o nylsf/float32.o nylsf/gsm610.o nylsf/htk.o \
	nylsf/id3.o nylsf/ima_adpcm.o nylsf/ima_oki_adpcm.o nylsf/interleave.o \
	nylsf/ircam.o nylsf/macbinary3.o nylsf/macos.o nylsf/mat4.o \
	nylsf/mat5.o nylsf/mpc2k.o nylsf/ms_adpcm.o nylsf/nist.o nylsf/ogg.o \
	nylsf/ogg_vorbis.o nylsf/paf.o nylsf/pcm.o nylsf/pvf.o nylsf/raw.o \
	nylsf/rf64.o nylsf/rx2.o nylsf/sd2.o nylsf/sds.o nylsf/sndfile.o \
	nylsf/strings.o nylsf/svx.o nylsf/txw.o nylsf/ulaw.o nylsf/voc.o \
	nylsf/vox_adpcm.o nylsf/w64.o nylsf/wav.o nylsf/wav_w64.o nylsf/wve.o \
	nylsf/xi.o nylsf/g72x.o nylsf/GSM610/add.o nylsf/GSM610/code.o \
	nylsf/GSM610/decode.o nylsf/GSM610/gsm_create.o \
	nylsf/GSM610/gsm_decode.o nylsf/GSM610/gsm_destroy.o \
	nylsf/GSM610/gsm_encode.o nylsf/GSM610/gsm_option.o \
	nylsf/GSM610/long_term.o nylsf/GSM610/lpc.o nylsf/GSM610/preprocess.o \
	nylsf/GSM610/rpe.o nylsf/GSM610/short_term.o nylsf/GSM610/table.o \
	nylsf/G72x/g721.o nylsf/G72x/g723_16.o nylsf/G72x/g723_24.o \
	nylsf/G72x/g723_40.o nylsf/G72x/g72x.o nyqsrc/debug.o nyqsrc/falloc.o \
	nyqsrc/local.o nyqsrc/handlers.o nyqsrc/multiread.o nyqsrc/seqext.o \
	nyqsrc/seqinterf.o nyqsrc/stats.o nyqsrc/ffilterkit.o nyqsrc/sound.o \
	nyqsrc/add.o nyqsrc/avg.o nyqsrc/compose.o nyqsrc/convolve.o \
	nyqsrc/downsample.o nyqsrc/fft.o nyqsrc/inverse.o nyqsrc/multiseq.o \
	nyqsrc/resamp.o nyqsrc/resampv.o nyqsrc/samples.o nyqsrc/sndmax.o \
	nyqsrc/sndread.o nyqsrc/sndseq.o nyqsrc/sndsliders.o \
	nyqsrc/sliderdata.o nyqsrc/sndwritepa.o nyqsrc/yin.o \
	nyqsrc/nyq-osc-server.o nyqsrc/trigger.o nyqsrc/lpanal.o \
	nyqsrc/phasevocoder.o nyqsrc/pvshell.o nyqstk/src/Generator.o \
	nyqstk/src/SineWave.o nyqstk/src/Function.o nyqstk/src/FileRead.o \
	nyqstk/src/FileWvIn.o nyqstk/src/Effect.o nyqstk/src/Clarinet.o \
	nyqstk/src/Delay.o nyqstk/src/DelayL.o nyqstk/src/Envelope.o \
	nyqstk/src/Filter.o nyqstk/src/Instrmnt.o nyqstk/src/Noise.o \
	nyqstk/src/OneZero.o nyqstk/src/ReedTable.o nyqstk/src/Saxofony.o \
	nyqstk/src/Stk.o nyqstk/src/WaveLoop.o nyqstk/src/WvIn.o \
	nyqstk/src/NRev.o nyqstk/src/JCRev.o nyqstk/src/PRCRev.o \
	nyqstk/src/PitShift.o nyqstk/src/Chorus.o nyqstk/src/Bowed.o \
	nyqstk/src/BowTable.o nyqstk/src/ADSR.o nyqstk/src/OnePole.o \
	nyqstk/src/BiQuad.o nyqstk/src/BandedWG.o nyqstk/src/DelayA.o \
	nyqstk/src/Mandolin.o nyqstk/src/PluckTwo.o nyqstk/src/Sitar.o \
	nyqstk/src/ModalBar.o nyqstk/src/Modal.o nyqstk/src/Flute.o \
	nyqstk/src/JetTable.o nyqstk/src/PoleZero.o nyqstk/stkinit.o \
	nyqstk/instr.o nyqstk/stkint.o ffts/src/fftext.o ffts/src/fftlib.o \
	ffts/src/matlib.o nyqsrc/sndfnint.o nyqsrc/seqfnint.o \
	sys/unix/osstuff.o sys/unix/term.o

# Sound functions to add to xlisp
SNDFNINT_HDRS =  nyqsrc/sndfmt.h nylsf/sndfile.h nyqsrc/sound.h \
	nyqsrc/add.h nyqsrc/avg.h nyqsrc/compose.h nyqsrc/convolve.h \
	nyqsrc/downsample.h nyqsrc/fft.h nyqsrc/inverse.h nyqsrc/multiseq.h \
	nyqsrc/resamp.h nyqsrc/resampv.h nyqsrc/samples.h nyqsrc/sndmax.h \
	nyqsrc/sndread.h nyqsrc/sndseq.h nyqsrc/sndsliders.h \
	nyqsrc/sliderdata.h nyqsrc/sndwritepa.h nyqsrc/yin.h \
	nyqsrc/nyq-osc-server.h nyqsrc/trigger.h nyqsrc/lpanal.h \
	nyqsrc/phasevocoder.h nyqsrc/pvshell.h tran/abs.h tran/allpoles.h \
	tran/alpass.h tran/alpasscv.h tran/alpassvv.h tran/amosc.h \
	tran/areson.h tran/aresonvc.h tran/aresoncv.h tran/aresonvv.h \
	tran/atone.h tran/atonev.h tran/biquadfilt.h tran/buzz.h tran/chase.h \
	tran/clip.h tran/congen.h tran/const.h tran/coterm.h tran/delaycc.h \
	tran/delaycv.h tran/eqbandvvv.h tran/exp.h tran/follow.h tran/fmosc.h \
	tran/fromobject.h tran/fromarraystream.h tran/gate.h tran/ifft.h \
	tran/instrclar.h tran/instrclarall.h tran/instrclarfreq.h \
	tran/instrsax.h tran/instrsaxall.h tran/instrsaxfreq.h tran/integrate.h \
	tran/log.h tran/lpreson.h tran/maxv.h tran/offset.h tran/oneshot.h \
	tran/osc.h tran/partial.h tran/pluck.h tran/prod.h tran/pwl.h \
	tran/quantize.h tran/recip.h tran/reson.h tran/resonvc.h tran/resoncv.h \
	tran/resonvv.h tran/sampler.h tran/scale.h tran/shape.h tran/sine.h \
	tran/siosc.h tran/slope.h tran/sqrt.h tran/tapf.h tran/tapv.h \
	tran/tone.h tran/tonev.h tran/upsample.h tran/white.h tran/stkrev.h \
	tran/stkpitshift.h tran/stkchorus.h tran/instrbow.h \
	tran/instrbowedfreq.h tran/instrbanded.h tran/instrmandolin.h \
	tran/instrsitar.h tran/instrmodalbar.h tran/instrflute.h \
	tran/instrflutefreq.h tran/instrfluteall.h tran/fmfb.h tran/fmfbv.h \
	nyqsrc/sndwrite.h

SEQFNINT_HDRS =  cmt/seqdecls.h nyqsrc/seqext.h cmt/seq.h \
	nyqsrc/seqinterf.h cmt/seqread.h cmt/seqmread.h cmt/seqwrite.h \
	cmt/seqmwrite.h



liblo/Makefile:
	cd liblo; ./configure CFLAGS=-m32 LDFLAGS=-m32 CXXFLAGS=-m32 --enable-static --disable-shared
	# sometimes, residual files cause problems
	cd liblo; make clean

$(LIBLO_PATH)/liblo.a: liblo/Makefile
	cd liblo; make

bin/ser-to-osc: $(LIBLO_PATH)/liblo.a
	mkdir -p bin
	$(CC) -c $(CFLAGS) liblo/ser-to-osc/ser-to-osc.cpp \
	      -o liblo/ser-to-osc/ser-to-osc.o
	$(LN)  liblo/ser-to-osc/ser-to-osc.o -o bin/ser-to-osc $(LFLAGS)

bin/test-client: $(LIBLO_PATH)/liblo.a
	mkdir -p bin
	$(CC) -c $(CFLAGS) liblo/test-client/test-client.c \
	      -o liblo/test-client/test-client.o
	$(LN) liblo/test-client/test-client.o -o bin/test-client  $(LFLAGS)

portaudio/Makefile:
	# note: without-jack avoids 32/64-bit link error on Debian
	cd portaudio; ./configure CFLAGS=-m32 LDFLAGS=-m32 CXXFLAGS=-m32 --enable-static --disable-shared --without-jack --with-alsa
	# sometimes, residual files cause problems
	cd portaudio; make clean

$(LIBPA_PATH)/libportaudio.a: portaudio/Makefile
	cd portaudio; make lib/libportaudio.la

libogg/Makefile:
	cd libogg; ./configure CFLAGS=-m32 LDFLAGS=-m32 CXXFLAGS=-m32 --enable-static --disable-shared

$(LIBOGG_PATH)/libogg.a: libogg/Makefile
	cd libogg; make

# NOTE: libvorbis/configure on a 64-bit machine will expect to find
#  libogg installed (even though we are not going to use the installed
#  libogg library, and even though the installed libogg library will
#  be for 64-bit architecture. This represents a bug in configure
#  because it checks for a 64-bit library when it is building for
#  a 32-bit architecture (we pass in CFLAGS=-m32). In spite of the 
#  bug, configure will build a Makefile that will build a 32-bit
#  libvorbis library that we need. We will link it with other 
#  32-bit code including 32-bit libogg.a

libvorbis/Makefile:
	cd libvorbis; ./configure CFLAGS=-m32 LDFLAGS=-m32 CXXFLAGS=-m32 --enable-static --disable-shared

$(LIBVORBIS_PATH)/libvorbis.a: libvorbis/Makefile
	cd libvorbis; make

$(LIBVORBIS_PATH)/libvorbisfile.a: libvorbis/Makefile
	cd libvorbis; make

$(LIBVORBIS_PATH)/libvorbisenc.a: libvorbis/Makefile
	cd libvorbis; make
