=== debian/changelog ===
audacity (2.2.1-1) unstable; urgency=medium

  * Add filter option to gbp.conf file.
  * New upstream version 2.2.1
  * Introduce postclone.sh script to ignore .pc/ dir.
  * Patches refreshed.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 11 Dec 2017 12:20:41 +0100

audacity (2.2.0-2) unstable; urgency=medium

  * Fix FTBFS on non-x86 archs. (Closes: #882173)
    Thanks to James Cowgill <jcowgill@debian.org>

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Fri, 24 Nov 2017 18:23:25 +0100

audacity (2.2.0-1) unstable; urgency=medium

  [ Sebastian Ramacher ]
  * New upstream release. (Closes: #858173)
  * debian/{control,compat,rules}: Bump debhelper compat to 10.
  * deian/compat:
    - Bump Standards-Version.

  [ Jaromír Mikeš ]
  * Fix watch file.
  * Add myself as uploader.
  * New upstream version 2.2.0

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 19 Nov 2017 19:28:34 +0100
